# Python imports

# Lib imports

# Application imports
import gi
gi.require_version('Gtk', '3.0')
gi.require_version('Gdk', '3.0')
from gi.repository import Gtk
from gi.repository import Gdk



class DynamicHeaderWidget(Gtk.Box):
    def __init__(self, move_callback, x, y):
        super(DynamicHeaderWidget, self).__init__()

        self._move_callback = move_callback
        self._current_x     = x
        self._current_y     = y

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        self.set_orientation(0)

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        drag_eve    = Gtk.EventBox()
        hresize_eve = Gtk.EventBox()
        self.is_dragging = False

        label1 = Gtk.Label(label="")
        label2 = Gtk.Label(label="....")
        label3 = Gtk.Label(label="< >")

        drag_eve.set_above_child(True)
        hresize_eve.set_above_child(True)
        label1.set_hexpand(True)
        label2.set_hexpand(True)
        label3.set_hexpand(True)
        label2.set_yalign(0.5)
        label3.set_yalign(0.5)
        label3.set_xalign(1.0)

        drag_eve.add(label2)
        hresize_eve.add(label3)

        URI_TARGET_TYPE  = 80
        uri_target       = Gtk.TargetEntry.new('text/uri-list', Gtk.TargetFlags(0), URI_TARGET_TYPE)
        targets          = [ uri_target ]
        flags            = Gtk.DestDefaults.ALL
        action           = Gdk.DragAction.COPY
        drag_eve.drag_dest_set(flags, targets, action)

        drag_eve.connect("button-press-event", self._toggle_drag_start)
        drag_eve.connect("motion-notify-event", self._do_drag_motion_call)
        drag_eve.connect("button-release-event", self._toggle_drag_start)

        self.add(label1)
        self.add(drag_eve)
        self.add(hresize_eve)

    def _toggle_drag_start(self, widget = None, eve = None):
        self.is_dragging = not self.is_dragging

    def _do_drag_motion_call(self, widget = None, eve = None):
        if self.is_dragging:
            self._move_callback(self.get_parent(), self._current_x, self._current_y, self.set_current_xy)

    def set_current_xy(self, x, y):
        self._current_x = x
        self._current_y = y
